// La largeur et la hauteur de la photo capturée. On utilisera
// une largeur fixe et on calculera la hauteur pour correspondre
// aux proportions du flux vidéo d'entrée.
const width = 2560; // On met à l'échelle la photo pour avoir cette largeur
let height = 0; // On calcule cette valeur ensuite selon le flux d'entrée

// |streaming| indique si le flux vidéo est en cours
// Lorsqu'on commence, ce n'est pas le cas (false).

let streaming = false;

// On référence les éléments HTML qu'il faudra configurer ou contrôler.
// Ils seront définis lors de la fonction startup().

let video = null;
let canvas = null;
let photo = null;
let startbutton = null;
let fullscreen = false;
data = null;
retour = document.getElementById("retour");
retour.style.display = '';
document.getElementById("progressBar").style.display = 'none';
document.getElementById("photo").style.display = 'none';
document.getElementById("canvas").style.display = 'none';
document.getElementById("envoyer").style.display = 'none';
console.log(location);

classe = document.getElementById("classe").value;
chapitre = document.getElementById("chapitre").value;

document.getElementById("renseignement").innerHTML = classe + " / " + chapitre;

retour.addEventListener('click', () => {

    if (document.getElementById("divclic").style.display == 'none') {
        document.getElementById("retour").innerHTML = '<i class="fa fa-folder-o" aria-hidden="true"></i><span id="fa-dossier" class="spanboutton"></span> ';
        document.getElementById("envoyer").style.display = 'none';


        document.getElementById("divclic").style.display = '';
        document.getElementById("photo").style.display = 'none';
        clearphoto();
    } else {
        classe = document.getElementById("classe").value;
        chapitre = document.getElementById("chapitre").value;
        var nouvellelocation = (location).toString();
        console.log(nouvellelocation);
        nouvellelocation = nouvellelocation.replace('photo.php', 'admin.php');
        location = nouvellelocation;
    }
});

function showViewLiveResultButton() {
    if (window.self !== window.top) {
        // On s'assure que si notre document est dans une iframe,
        // on invite la personne à ouvrir l'exemple dans un onglet
        // ou une fenêtre séparée. Sinon, le navigateur n'envoie
        // pas la demande d'accès à la caméra.
        document.querySelector(".contentarea").remove();
        const button = document.createElement("button");
        button.textContent = "Voir le résultat de l'exemple dont le code est présenté avant";
        document.body.append(button);
        button.addEventListener("click", () => window.open(location.href));
        return true;
    }
    return false;
}

function startup() {
    if (showViewLiveResultButton()) {
        return;
    }
    video = document.getElementById("video");
    canvas = document.getElementById("canvas");
    photo = document.getElementById("photo");
    startbutton = document.getElementById("divclic");

    navigator.mediaDevices
        .getUserMedia({
            //video: true,
            video: {
                facingMode: "environment"
            },
            audio: false
        })
        .then((stream) => {
            video.srcObject = stream;
            video.play();

        })
        .catch((err) => {
            console.error(`Une erreur est survenue : ${err}`);
        });

    video.addEventListener(
        "canplay",
        (ev) => {
            if (!streaming) {
                height = video.videoHeight / (video.videoWidth / width);

                // Firefox a un bug où la hauteur ne peut pas être lue
                // à partir de la vidéo. On prend des précautions.

                if (isNaN(height)) {
                    height = width / (4 / 3);
                }

                video.setAttribute("width", width);
                video.setAttribute("height", height);
                canvas.setAttribute("width", width);
                canvas.setAttribute("height", height);
                streaming = true;

            }
        },
        false
    );

    startbutton.addEventListener(
        "click",
        (ev) => {

            takepicture();

            fullscreen = false;
            document.getElementById("divclic").style.display = 'none';
            document.getElementById("photo").style.display = '';
            document.getElementById("envoyer").style.display = '';
            document.getElementById("retour").innerHTML = '<i class="fa fa-arrow-left"></i><span id="fa-annule" class="spanboutton"></span>';

            retour.style.display = '';
            ev.preventDefault();

        },
        false
    );

    clearphoto();
}

// On remplit le cadre de la photo pour indiquer l'absence
// d'image capturée.

function clearphoto() {
    const context = canvas.getContext("2d");
    context.fillStyle = "#AAA";
    context.fillRect(0, 0, canvas.width, canvas.height);

    const data = canvas.toDataURL("image/jpeg");
    photo.setAttribute("src", data);
}

// On capture une photo en récupérant le contenu courant de la
// vidéo, qu'on dessine dans un canevas puis qu'on convertit
// en une URL de données contenant l'image au format PNG.
// En utilisant un canevas en dehors de l'écran, on peut
// modifier sa taille et/ou appliquer d'autres modifications
// avant de l'afficher à l'écran.

function takepicture() {
    const context = canvas.getContext("2d");
    if (width && height) {
        canvas.width = width;
        canvas.height = height;
        context.drawImage(video, 0, 0, width, height);

        data = canvas.toDataURL("image/jpeg");
			

        photo.setAttribute("src", data);
    } else {
        clearphoto();
    }
}


   // Fonction pour prendre une photo
        function takePhoto() {
            canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height);
            const photoURL = canvas.toDataURL('image/jpeg');
            const link = document.createElement('a');
            link.href = photoURL;
            link.download = 'photo.jpg';
            link.click();
        }
        
        
// On met en place un gestionnaire d'évènement pour exécuter
// le code lorsque le chargement du document est terminé.
window.addEventListener("load", startup, false);



function uploadEx() {
    var canvas = document.getElementById("canvas");
    var dataURL = canvas.toDataURL("image/jpeg");
    
    //enregistrement local
    const link = document.createElement('a');
	link.href = dataURL;
	
	// création du nom du fichier
	
	// Récupérer la date et l'heure actuelles
	 var currentDate = new Date();

	// Récupérer la date au format "AAAA-MM-JJ"
	var annee = currentDate.getFullYear();
	var mois = String(currentDate.getMonth() + 1).padStart(2, '0');
	var jour = String(currentDate.getDate()).padStart(2, '0');

	// Récupérer l'heure au format "HH:MM:SS"
	var heure = String(currentDate.getHours()).padStart(2, '0');
	var minute = String(currentDate.getMinutes()).padStart(2, '0');
	var seconde = String(currentDate.getSeconds()).padStart(2, '0');

	var nomfichier=`${annee}${mois}${jour}_${heure}${minute}${seconde}`;
	link.download = nomfichier+'.jpg';
	link.click();
    //fin enregistrement local
    
    
    
    document.getElementById('imgData').value = dataURL;
    var fd = new FormData(document.forms["form1"]);

    var xhr = new XMLHttpRequest();
    xhr.open('POST', 'testSave.php', true);
    document.getElementById("progressBar").style.display = '';
    document.getElementById("progressBar").value = 0;
    xhr.upload.onprogress = function(e) {
        if (e.lengthComputable) {
            var percentComplete = Math.floor((e.loaded / e.total) * 100);
            console.log(percentComplete + '% télévervé');
            document.getElementById("progressBar").value = percentComplete;

        }
    };

    xhr.onload = function() {

        document.getElementById("progressBar").style.display = 'none';
    };
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4 && xhr.status === 200) {
            console.log(xhr.responseText);
            if ((xhr.responseText).indexOf("ERREUR") > -1) {
                alert('Impossible de sauvegarder le fichier.');

            } else {
                alert('Succès');
            }
        }

    }
    xhr.send(fd);
};
