let deferredPrompt;

self.addEventListener('beforeinstallprompt', (event) => {
  event.preventDefault();
  deferredPrompt = event;
});

self.addEventListener('notificationclick', function(event) {
  event.notification.close();
  if (event.action === 'add-to-home-screen' && deferredPrompt) {
    deferredPrompt.prompt().then((choiceResult) => {
      if (choiceResult.outcome === 'accepted') {
        console.log('User accepted the A2HS prompt');
      } else {
        console.log('User dismissed the A2HS prompt');
      }
      deferredPrompt = null;
    });
  }
});

self.addEventListener('install', function(event) {
  self.skipWaiting();
});

self.addEventListener('activate', function(event) {
  console.log('Service worker activated');
  event.waitUntil(
    self.clients.matchAll({ type: 'window' }).then(function(clientList) {
      if (clientList.length > 0) {
        return clientList[0].navigate(clientList[0].url);
      }
    })
  );
  self.registration.showNotification('Installer', {
    actions: [{
      action: 'add-to-home-screen',
      title: 'Ajouter à l\'écran d\'accueil'
    }],
    body: 'Cliquez pour ajouter le raccourci à l\'écran d\'accueil'
  });
});
